//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private hpcAmpRSIIndicator[] cachehpcAmpRSIIndicator = null;
        private hpcHSIArrowsIndicator[] cachehpcHSIArrowsIndicator = null;
        private hpcHSIIndicator[] cachehpcHSIIndicator = null;
        private hpcPatternsIndicator[] cachehpcPatternsIndicator = null;
        private hpcPiPhiBands[] cachehpcPiPhiBands = null;
        private hpcRSIBammIndicator[] cachehpcRSIBammIndicator = null;
        private hpcVolumeSpike[] cachehpcVolumeSpike = null;

        private static hpcAmpRSIIndicator checkhpcAmpRSIIndicator = new hpcAmpRSIIndicator();
        private static hpcHSIArrowsIndicator checkhpcHSIArrowsIndicator = new hpcHSIArrowsIndicator();
        private static hpcHSIIndicator checkhpcHSIIndicator = new hpcHSIIndicator();
        private static hpcPatternsIndicator checkhpcPatternsIndicator = new hpcPatternsIndicator();
        private static hpcPiPhiBands checkhpcPiPhiBands = new hpcPiPhiBands();
        private static hpcRSIBammIndicator checkhpcRSIBammIndicator = new hpcRSIBammIndicator();
        private static hpcVolumeSpike checkhpcVolumeSpike = new hpcVolumeSpike();

        /// <summary>
        /// Amp RSI Indicator
        /// </summary>
        /// <returns></returns>
        public hpcAmpRSIIndicator hpcAmpRSIIndicator(double fill_Opacity, Color fillColor)
        {
            return hpcAmpRSIIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Amp RSI Indicator
        /// </summary>
        /// <returns></returns>
        public hpcAmpRSIIndicator hpcAmpRSIIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            if (cachehpcAmpRSIIndicator != null)
                for (int idx = 0; idx < cachehpcAmpRSIIndicator.Length; idx++)
                    if (Math.Abs(cachehpcAmpRSIIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcAmpRSIIndicator[idx].FillColor == fillColor && cachehpcAmpRSIIndicator[idx].EqualsInput(input))
                        return cachehpcAmpRSIIndicator[idx];

            lock (checkhpcAmpRSIIndicator)
            {
                checkhpcAmpRSIIndicator.Fill_Opacity = fill_Opacity;
                fill_Opacity = checkhpcAmpRSIIndicator.Fill_Opacity;
                checkhpcAmpRSIIndicator.FillColor = fillColor;
                fillColor = checkhpcAmpRSIIndicator.FillColor;

                if (cachehpcAmpRSIIndicator != null)
                    for (int idx = 0; idx < cachehpcAmpRSIIndicator.Length; idx++)
                        if (Math.Abs(cachehpcAmpRSIIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcAmpRSIIndicator[idx].FillColor == fillColor && cachehpcAmpRSIIndicator[idx].EqualsInput(input))
                            return cachehpcAmpRSIIndicator[idx];

                hpcAmpRSIIndicator indicator = new hpcAmpRSIIndicator();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Fill_Opacity = fill_Opacity;
                indicator.FillColor = fillColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                hpcAmpRSIIndicator[] tmp = new hpcAmpRSIIndicator[cachehpcAmpRSIIndicator == null ? 1 : cachehpcAmpRSIIndicator.Length + 1];
                if (cachehpcAmpRSIIndicator != null)
                    cachehpcAmpRSIIndicator.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachehpcAmpRSIIndicator = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Harmonic Strength Indicator Arrows
        /// </summary>
        /// <returns></returns>
        public hpcHSIArrowsIndicator hpcHSIArrowsIndicator(Color dn_Arrow_Color, Color up_Arrow_Color)
        {
            return hpcHSIArrowsIndicator(Input, dn_Arrow_Color, up_Arrow_Color);
        }

        /// <summary>
        /// Harmonic Strength Indicator Arrows
        /// </summary>
        /// <returns></returns>
        public hpcHSIArrowsIndicator hpcHSIArrowsIndicator(Data.IDataSeries input, Color dn_Arrow_Color, Color up_Arrow_Color)
        {
            if (cachehpcHSIArrowsIndicator != null)
                for (int idx = 0; idx < cachehpcHSIArrowsIndicator.Length; idx++)
                    if (cachehpcHSIArrowsIndicator[idx].Dn_Arrow_Color == dn_Arrow_Color && cachehpcHSIArrowsIndicator[idx].Up_Arrow_Color == up_Arrow_Color && cachehpcHSIArrowsIndicator[idx].EqualsInput(input))
                        return cachehpcHSIArrowsIndicator[idx];

            lock (checkhpcHSIArrowsIndicator)
            {
                checkhpcHSIArrowsIndicator.Dn_Arrow_Color = dn_Arrow_Color;
                dn_Arrow_Color = checkhpcHSIArrowsIndicator.Dn_Arrow_Color;
                checkhpcHSIArrowsIndicator.Up_Arrow_Color = up_Arrow_Color;
                up_Arrow_Color = checkhpcHSIArrowsIndicator.Up_Arrow_Color;

                if (cachehpcHSIArrowsIndicator != null)
                    for (int idx = 0; idx < cachehpcHSIArrowsIndicator.Length; idx++)
                        if (cachehpcHSIArrowsIndicator[idx].Dn_Arrow_Color == dn_Arrow_Color && cachehpcHSIArrowsIndicator[idx].Up_Arrow_Color == up_Arrow_Color && cachehpcHSIArrowsIndicator[idx].EqualsInput(input))
                            return cachehpcHSIArrowsIndicator[idx];

                hpcHSIArrowsIndicator indicator = new hpcHSIArrowsIndicator();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Dn_Arrow_Color = dn_Arrow_Color;
                indicator.Up_Arrow_Color = up_Arrow_Color;
                Indicators.Add(indicator);
                indicator.SetUp();

                hpcHSIArrowsIndicator[] tmp = new hpcHSIArrowsIndicator[cachehpcHSIArrowsIndicator == null ? 1 : cachehpcHSIArrowsIndicator.Length + 1];
                if (cachehpcHSIArrowsIndicator != null)
                    cachehpcHSIArrowsIndicator.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachehpcHSIArrowsIndicator = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Harmonic Strength Indicator
        /// </summary>
        /// <returns></returns>
        public hpcHSIIndicator hpcHSIIndicator(double fill_Opacity, Color fillColor)
        {
            return hpcHSIIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Harmonic Strength Indicator
        /// </summary>
        /// <returns></returns>
        public hpcHSIIndicator hpcHSIIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            if (cachehpcHSIIndicator != null)
                for (int idx = 0; idx < cachehpcHSIIndicator.Length; idx++)
                    if (Math.Abs(cachehpcHSIIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcHSIIndicator[idx].FillColor == fillColor && cachehpcHSIIndicator[idx].EqualsInput(input))
                        return cachehpcHSIIndicator[idx];

            lock (checkhpcHSIIndicator)
            {
                checkhpcHSIIndicator.Fill_Opacity = fill_Opacity;
                fill_Opacity = checkhpcHSIIndicator.Fill_Opacity;
                checkhpcHSIIndicator.FillColor = fillColor;
                fillColor = checkhpcHSIIndicator.FillColor;

                if (cachehpcHSIIndicator != null)
                    for (int idx = 0; idx < cachehpcHSIIndicator.Length; idx++)
                        if (Math.Abs(cachehpcHSIIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcHSIIndicator[idx].FillColor == fillColor && cachehpcHSIIndicator[idx].EqualsInput(input))
                            return cachehpcHSIIndicator[idx];

                hpcHSIIndicator indicator = new hpcHSIIndicator();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Fill_Opacity = fill_Opacity;
                indicator.FillColor = fillColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                hpcHSIIndicator[] tmp = new hpcHSIIndicator[cachehpcHSIIndicator == null ? 1 : cachehpcHSIIndicator.Length + 1];
                if (cachehpcHSIIndicator != null)
                    cachehpcHSIIndicator.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachehpcHSIIndicator = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Harmonic Patterns Indicator
        /// </summary>
        /// <returns></returns>
        public hpcPatternsIndicator hpcPatternsIndicator(int bars_To_Process, Color bearish_Leg_Color, Color bullish_Leg_Color, Color confirmed_Label_Color, Color confirmed_RatioLabel_Color, Color confirmed_RatioLine_Color, bool do_Alerts, bool do_Pattern_Fill, double fill_Opacity, bool hide_Inside, int label_Font_Size, double leg_Thickness, int max_Pattern_Length, int max_Points_Shared, int min_Pattern_Length, int most_Recent, bool none_Past_AC, bool none_Past_BD, Color pending_Label_Color, Color pending_Leg_Color, Color pending_RatioLabel_Color, Color pending_RatioLine_Color, Color potential_Label_Color, Color potential_Leg_Color, int potential_Logic, Color potential_RatioLabel_Color, Color potential_RatioLine_Color, int ratio_Font_Size, double ratio_Thickness, bool reverse_Zone_Labels, bool show_50, bool show_ABCD, bool show_AltBat, bool show_Bat, bool show_Bearish, bool show_Bullish, bool show_Butterfly, bool show_Crab, bool show_DeepCrab, bool show_Gartley, bool show_LicenseButton, bool show_Pending, bool show_Potential, bool show_Shark, bool show_Vertical_Line, bool strict_ABCD, double strict_ATRs, int target_Bars, int terminal_Bar_Font, int update_Interval, int update_Type, int zone_Bars, Color zone_Line_Bearish, Color zone_Line_Bullish, double zone_Line_Thickness, double zone_Opacity, Color zone_Text_Color, int zone_Text_FontSize)
        {
            return hpcPatternsIndicator(Input, bars_To_Process, bearish_Leg_Color, bullish_Leg_Color, confirmed_Label_Color, confirmed_RatioLabel_Color, confirmed_RatioLine_Color, do_Alerts, do_Pattern_Fill, fill_Opacity, hide_Inside, label_Font_Size, leg_Thickness, max_Pattern_Length, max_Points_Shared, min_Pattern_Length, most_Recent, none_Past_AC, none_Past_BD, pending_Label_Color, pending_Leg_Color, pending_RatioLabel_Color, pending_RatioLine_Color, potential_Label_Color, potential_Leg_Color, potential_Logic, potential_RatioLabel_Color, potential_RatioLine_Color, ratio_Font_Size, ratio_Thickness, reverse_Zone_Labels, show_50, show_ABCD, show_AltBat, show_Bat, show_Bearish, show_Bullish, show_Butterfly, show_Crab, show_DeepCrab, show_Gartley, show_LicenseButton, show_Pending, show_Potential, show_Shark, show_Vertical_Line, strict_ABCD, strict_ATRs, target_Bars, terminal_Bar_Font, update_Interval, update_Type, zone_Bars, zone_Line_Bearish, zone_Line_Bullish, zone_Line_Thickness, zone_Opacity, zone_Text_Color, zone_Text_FontSize);
        }

        /// <summary>
        /// Harmonic Patterns Indicator
        /// </summary>
        /// <returns></returns>
        public hpcPatternsIndicator hpcPatternsIndicator(Data.IDataSeries input, int bars_To_Process, Color bearish_Leg_Color, Color bullish_Leg_Color, Color confirmed_Label_Color, Color confirmed_RatioLabel_Color, Color confirmed_RatioLine_Color, bool do_Alerts, bool do_Pattern_Fill, double fill_Opacity, bool hide_Inside, int label_Font_Size, double leg_Thickness, int max_Pattern_Length, int max_Points_Shared, int min_Pattern_Length, int most_Recent, bool none_Past_AC, bool none_Past_BD, Color pending_Label_Color, Color pending_Leg_Color, Color pending_RatioLabel_Color, Color pending_RatioLine_Color, Color potential_Label_Color, Color potential_Leg_Color, int potential_Logic, Color potential_RatioLabel_Color, Color potential_RatioLine_Color, int ratio_Font_Size, double ratio_Thickness, bool reverse_Zone_Labels, bool show_50, bool show_ABCD, bool show_AltBat, bool show_Bat, bool show_Bearish, bool show_Bullish, bool show_Butterfly, bool show_Crab, bool show_DeepCrab, bool show_Gartley, bool show_LicenseButton, bool show_Pending, bool show_Potential, bool show_Shark, bool show_Vertical_Line, bool strict_ABCD, double strict_ATRs, int target_Bars, int terminal_Bar_Font, int update_Interval, int update_Type, int zone_Bars, Color zone_Line_Bearish, Color zone_Line_Bullish, double zone_Line_Thickness, double zone_Opacity, Color zone_Text_Color, int zone_Text_FontSize)
        {
            if (cachehpcPatternsIndicator != null)
                for (int idx = 0; idx < cachehpcPatternsIndicator.Length; idx++)
                    if (cachehpcPatternsIndicator[idx].Bars_To_Process == bars_To_Process && cachehpcPatternsIndicator[idx].Bearish_Leg_Color == bearish_Leg_Color && cachehpcPatternsIndicator[idx].Bullish_Leg_Color == bullish_Leg_Color && cachehpcPatternsIndicator[idx].Confirmed_Label_Color == confirmed_Label_Color && cachehpcPatternsIndicator[idx].Confirmed_RatioLabel_Color == confirmed_RatioLabel_Color && cachehpcPatternsIndicator[idx].Confirmed_RatioLine_Color == confirmed_RatioLine_Color && cachehpcPatternsIndicator[idx].Do_Alerts == do_Alerts && cachehpcPatternsIndicator[idx].Do_Pattern_Fill == do_Pattern_Fill && Math.Abs(cachehpcPatternsIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcPatternsIndicator[idx].Hide_Inside == hide_Inside && cachehpcPatternsIndicator[idx].Label_Font_Size == label_Font_Size && Math.Abs(cachehpcPatternsIndicator[idx].Leg_Thickness - leg_Thickness) <= double.Epsilon && cachehpcPatternsIndicator[idx].Max_Pattern_Length == max_Pattern_Length && cachehpcPatternsIndicator[idx].Max_Points_Shared == max_Points_Shared && cachehpcPatternsIndicator[idx].Min_Pattern_Length == min_Pattern_Length && cachehpcPatternsIndicator[idx].Most_Recent == most_Recent && cachehpcPatternsIndicator[idx].None_Past_AC == none_Past_AC && cachehpcPatternsIndicator[idx].None_Past_BD == none_Past_BD && cachehpcPatternsIndicator[idx].Pending_Label_Color == pending_Label_Color && cachehpcPatternsIndicator[idx].Pending_Leg_Color == pending_Leg_Color && cachehpcPatternsIndicator[idx].Pending_RatioLabel_Color == pending_RatioLabel_Color && cachehpcPatternsIndicator[idx].Pending_RatioLine_Color == pending_RatioLine_Color && cachehpcPatternsIndicator[idx].Potential_Label_Color == potential_Label_Color && cachehpcPatternsIndicator[idx].Potential_Leg_Color == potential_Leg_Color && cachehpcPatternsIndicator[idx].Potential_Logic == potential_Logic && cachehpcPatternsIndicator[idx].Potential_RatioLabel_Color == potential_RatioLabel_Color && cachehpcPatternsIndicator[idx].Potential_RatioLine_Color == potential_RatioLine_Color && cachehpcPatternsIndicator[idx].Ratio_Font_Size == ratio_Font_Size && Math.Abs(cachehpcPatternsIndicator[idx].Ratio_Thickness - ratio_Thickness) <= double.Epsilon && cachehpcPatternsIndicator[idx].Reverse_Zone_Labels == reverse_Zone_Labels && cachehpcPatternsIndicator[idx].Show_50 == show_50 && cachehpcPatternsIndicator[idx].Show_ABCD == show_ABCD && cachehpcPatternsIndicator[idx].Show_AltBat == show_AltBat && cachehpcPatternsIndicator[idx].Show_Bat == show_Bat && cachehpcPatternsIndicator[idx].Show_Bearish == show_Bearish && cachehpcPatternsIndicator[idx].Show_Bullish == show_Bullish && cachehpcPatternsIndicator[idx].Show_Butterfly == show_Butterfly && cachehpcPatternsIndicator[idx].Show_Crab == show_Crab && cachehpcPatternsIndicator[idx].Show_DeepCrab == show_DeepCrab && cachehpcPatternsIndicator[idx].Show_Gartley == show_Gartley && cachehpcPatternsIndicator[idx].Show_LicenseButton == show_LicenseButton && cachehpcPatternsIndicator[idx].Show_Pending == show_Pending && cachehpcPatternsIndicator[idx].Show_Potential == show_Potential && cachehpcPatternsIndicator[idx].Show_Shark == show_Shark && cachehpcPatternsIndicator[idx].Show_Vertical_Line == show_Vertical_Line && cachehpcPatternsIndicator[idx].Strict_ABCD == strict_ABCD && Math.Abs(cachehpcPatternsIndicator[idx].Strict_ATRs - strict_ATRs) <= double.Epsilon && cachehpcPatternsIndicator[idx].Target_Bars == target_Bars && cachehpcPatternsIndicator[idx].Terminal_Bar_Font == terminal_Bar_Font && cachehpcPatternsIndicator[idx].Update_Interval == update_Interval && cachehpcPatternsIndicator[idx].Update_Type == update_Type && cachehpcPatternsIndicator[idx].Zone_Bars == zone_Bars && cachehpcPatternsIndicator[idx].Zone_Line_Bearish == zone_Line_Bearish && cachehpcPatternsIndicator[idx].Zone_Line_Bullish == zone_Line_Bullish && Math.Abs(cachehpcPatternsIndicator[idx].Zone_Line_Thickness - zone_Line_Thickness) <= double.Epsilon && Math.Abs(cachehpcPatternsIndicator[idx].Zone_Opacity - zone_Opacity) <= double.Epsilon && cachehpcPatternsIndicator[idx].Zone_Text_Color == zone_Text_Color && cachehpcPatternsIndicator[idx].Zone_Text_FontSize == zone_Text_FontSize && cachehpcPatternsIndicator[idx].EqualsInput(input))
                        return cachehpcPatternsIndicator[idx];

            lock (checkhpcPatternsIndicator)
            {
                checkhpcPatternsIndicator.Bars_To_Process = bars_To_Process;
                bars_To_Process = checkhpcPatternsIndicator.Bars_To_Process;
                checkhpcPatternsIndicator.Bearish_Leg_Color = bearish_Leg_Color;
                bearish_Leg_Color = checkhpcPatternsIndicator.Bearish_Leg_Color;
                checkhpcPatternsIndicator.Bullish_Leg_Color = bullish_Leg_Color;
                bullish_Leg_Color = checkhpcPatternsIndicator.Bullish_Leg_Color;
                checkhpcPatternsIndicator.Confirmed_Label_Color = confirmed_Label_Color;
                confirmed_Label_Color = checkhpcPatternsIndicator.Confirmed_Label_Color;
                checkhpcPatternsIndicator.Confirmed_RatioLabel_Color = confirmed_RatioLabel_Color;
                confirmed_RatioLabel_Color = checkhpcPatternsIndicator.Confirmed_RatioLabel_Color;
                checkhpcPatternsIndicator.Confirmed_RatioLine_Color = confirmed_RatioLine_Color;
                confirmed_RatioLine_Color = checkhpcPatternsIndicator.Confirmed_RatioLine_Color;
                checkhpcPatternsIndicator.Do_Alerts = do_Alerts;
                do_Alerts = checkhpcPatternsIndicator.Do_Alerts;
                checkhpcPatternsIndicator.Do_Pattern_Fill = do_Pattern_Fill;
                do_Pattern_Fill = checkhpcPatternsIndicator.Do_Pattern_Fill;
                checkhpcPatternsIndicator.Fill_Opacity = fill_Opacity;
                fill_Opacity = checkhpcPatternsIndicator.Fill_Opacity;
                checkhpcPatternsIndicator.Hide_Inside = hide_Inside;
                hide_Inside = checkhpcPatternsIndicator.Hide_Inside;
                checkhpcPatternsIndicator.Label_Font_Size = label_Font_Size;
                label_Font_Size = checkhpcPatternsIndicator.Label_Font_Size;
                checkhpcPatternsIndicator.Leg_Thickness = leg_Thickness;
                leg_Thickness = checkhpcPatternsIndicator.Leg_Thickness;
                checkhpcPatternsIndicator.Max_Pattern_Length = max_Pattern_Length;
                max_Pattern_Length = checkhpcPatternsIndicator.Max_Pattern_Length;
                checkhpcPatternsIndicator.Max_Points_Shared = max_Points_Shared;
                max_Points_Shared = checkhpcPatternsIndicator.Max_Points_Shared;
                checkhpcPatternsIndicator.Min_Pattern_Length = min_Pattern_Length;
                min_Pattern_Length = checkhpcPatternsIndicator.Min_Pattern_Length;
                checkhpcPatternsIndicator.Most_Recent = most_Recent;
                most_Recent = checkhpcPatternsIndicator.Most_Recent;
                checkhpcPatternsIndicator.None_Past_AC = none_Past_AC;
                none_Past_AC = checkhpcPatternsIndicator.None_Past_AC;
                checkhpcPatternsIndicator.None_Past_BD = none_Past_BD;
                none_Past_BD = checkhpcPatternsIndicator.None_Past_BD;
                checkhpcPatternsIndicator.Pending_Label_Color = pending_Label_Color;
                pending_Label_Color = checkhpcPatternsIndicator.Pending_Label_Color;
                checkhpcPatternsIndicator.Pending_Leg_Color = pending_Leg_Color;
                pending_Leg_Color = checkhpcPatternsIndicator.Pending_Leg_Color;
                checkhpcPatternsIndicator.Pending_RatioLabel_Color = pending_RatioLabel_Color;
                pending_RatioLabel_Color = checkhpcPatternsIndicator.Pending_RatioLabel_Color;
                checkhpcPatternsIndicator.Pending_RatioLine_Color = pending_RatioLine_Color;
                pending_RatioLine_Color = checkhpcPatternsIndicator.Pending_RatioLine_Color;
                checkhpcPatternsIndicator.Potential_Label_Color = potential_Label_Color;
                potential_Label_Color = checkhpcPatternsIndicator.Potential_Label_Color;
                checkhpcPatternsIndicator.Potential_Leg_Color = potential_Leg_Color;
                potential_Leg_Color = checkhpcPatternsIndicator.Potential_Leg_Color;
                checkhpcPatternsIndicator.Potential_Logic = potential_Logic;
                potential_Logic = checkhpcPatternsIndicator.Potential_Logic;
                checkhpcPatternsIndicator.Potential_RatioLabel_Color = potential_RatioLabel_Color;
                potential_RatioLabel_Color = checkhpcPatternsIndicator.Potential_RatioLabel_Color;
                checkhpcPatternsIndicator.Potential_RatioLine_Color = potential_RatioLine_Color;
                potential_RatioLine_Color = checkhpcPatternsIndicator.Potential_RatioLine_Color;
                checkhpcPatternsIndicator.Ratio_Font_Size = ratio_Font_Size;
                ratio_Font_Size = checkhpcPatternsIndicator.Ratio_Font_Size;
                checkhpcPatternsIndicator.Ratio_Thickness = ratio_Thickness;
                ratio_Thickness = checkhpcPatternsIndicator.Ratio_Thickness;
                checkhpcPatternsIndicator.Reverse_Zone_Labels = reverse_Zone_Labels;
                reverse_Zone_Labels = checkhpcPatternsIndicator.Reverse_Zone_Labels;
                checkhpcPatternsIndicator.Show_50 = show_50;
                show_50 = checkhpcPatternsIndicator.Show_50;
                checkhpcPatternsIndicator.Show_ABCD = show_ABCD;
                show_ABCD = checkhpcPatternsIndicator.Show_ABCD;
                checkhpcPatternsIndicator.Show_AltBat = show_AltBat;
                show_AltBat = checkhpcPatternsIndicator.Show_AltBat;
                checkhpcPatternsIndicator.Show_Bat = show_Bat;
                show_Bat = checkhpcPatternsIndicator.Show_Bat;
                checkhpcPatternsIndicator.Show_Bearish = show_Bearish;
                show_Bearish = checkhpcPatternsIndicator.Show_Bearish;
                checkhpcPatternsIndicator.Show_Bullish = show_Bullish;
                show_Bullish = checkhpcPatternsIndicator.Show_Bullish;
                checkhpcPatternsIndicator.Show_Butterfly = show_Butterfly;
                show_Butterfly = checkhpcPatternsIndicator.Show_Butterfly;
                checkhpcPatternsIndicator.Show_Crab = show_Crab;
                show_Crab = checkhpcPatternsIndicator.Show_Crab;
                checkhpcPatternsIndicator.Show_DeepCrab = show_DeepCrab;
                show_DeepCrab = checkhpcPatternsIndicator.Show_DeepCrab;
                checkhpcPatternsIndicator.Show_Gartley = show_Gartley;
                show_Gartley = checkhpcPatternsIndicator.Show_Gartley;
                checkhpcPatternsIndicator.Show_LicenseButton = show_LicenseButton;
                show_LicenseButton = checkhpcPatternsIndicator.Show_LicenseButton;
                checkhpcPatternsIndicator.Show_Pending = show_Pending;
                show_Pending = checkhpcPatternsIndicator.Show_Pending;
                checkhpcPatternsIndicator.Show_Potential = show_Potential;
                show_Potential = checkhpcPatternsIndicator.Show_Potential;
                checkhpcPatternsIndicator.Show_Shark = show_Shark;
                show_Shark = checkhpcPatternsIndicator.Show_Shark;
                checkhpcPatternsIndicator.Show_Vertical_Line = show_Vertical_Line;
                show_Vertical_Line = checkhpcPatternsIndicator.Show_Vertical_Line;
                checkhpcPatternsIndicator.Strict_ABCD = strict_ABCD;
                strict_ABCD = checkhpcPatternsIndicator.Strict_ABCD;
                checkhpcPatternsIndicator.Strict_ATRs = strict_ATRs;
                strict_ATRs = checkhpcPatternsIndicator.Strict_ATRs;
                checkhpcPatternsIndicator.Target_Bars = target_Bars;
                target_Bars = checkhpcPatternsIndicator.Target_Bars;
                checkhpcPatternsIndicator.Terminal_Bar_Font = terminal_Bar_Font;
                terminal_Bar_Font = checkhpcPatternsIndicator.Terminal_Bar_Font;
                checkhpcPatternsIndicator.Update_Interval = update_Interval;
                update_Interval = checkhpcPatternsIndicator.Update_Interval;
                checkhpcPatternsIndicator.Update_Type = update_Type;
                update_Type = checkhpcPatternsIndicator.Update_Type;
                checkhpcPatternsIndicator.Zone_Bars = zone_Bars;
                zone_Bars = checkhpcPatternsIndicator.Zone_Bars;
                checkhpcPatternsIndicator.Zone_Line_Bearish = zone_Line_Bearish;
                zone_Line_Bearish = checkhpcPatternsIndicator.Zone_Line_Bearish;
                checkhpcPatternsIndicator.Zone_Line_Bullish = zone_Line_Bullish;
                zone_Line_Bullish = checkhpcPatternsIndicator.Zone_Line_Bullish;
                checkhpcPatternsIndicator.Zone_Line_Thickness = zone_Line_Thickness;
                zone_Line_Thickness = checkhpcPatternsIndicator.Zone_Line_Thickness;
                checkhpcPatternsIndicator.Zone_Opacity = zone_Opacity;
                zone_Opacity = checkhpcPatternsIndicator.Zone_Opacity;
                checkhpcPatternsIndicator.Zone_Text_Color = zone_Text_Color;
                zone_Text_Color = checkhpcPatternsIndicator.Zone_Text_Color;
                checkhpcPatternsIndicator.Zone_Text_FontSize = zone_Text_FontSize;
                zone_Text_FontSize = checkhpcPatternsIndicator.Zone_Text_FontSize;

                if (cachehpcPatternsIndicator != null)
                    for (int idx = 0; idx < cachehpcPatternsIndicator.Length; idx++)
                        if (cachehpcPatternsIndicator[idx].Bars_To_Process == bars_To_Process && cachehpcPatternsIndicator[idx].Bearish_Leg_Color == bearish_Leg_Color && cachehpcPatternsIndicator[idx].Bullish_Leg_Color == bullish_Leg_Color && cachehpcPatternsIndicator[idx].Confirmed_Label_Color == confirmed_Label_Color && cachehpcPatternsIndicator[idx].Confirmed_RatioLabel_Color == confirmed_RatioLabel_Color && cachehpcPatternsIndicator[idx].Confirmed_RatioLine_Color == confirmed_RatioLine_Color && cachehpcPatternsIndicator[idx].Do_Alerts == do_Alerts && cachehpcPatternsIndicator[idx].Do_Pattern_Fill == do_Pattern_Fill && Math.Abs(cachehpcPatternsIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcPatternsIndicator[idx].Hide_Inside == hide_Inside && cachehpcPatternsIndicator[idx].Label_Font_Size == label_Font_Size && Math.Abs(cachehpcPatternsIndicator[idx].Leg_Thickness - leg_Thickness) <= double.Epsilon && cachehpcPatternsIndicator[idx].Max_Pattern_Length == max_Pattern_Length && cachehpcPatternsIndicator[idx].Max_Points_Shared == max_Points_Shared && cachehpcPatternsIndicator[idx].Min_Pattern_Length == min_Pattern_Length && cachehpcPatternsIndicator[idx].Most_Recent == most_Recent && cachehpcPatternsIndicator[idx].None_Past_AC == none_Past_AC && cachehpcPatternsIndicator[idx].None_Past_BD == none_Past_BD && cachehpcPatternsIndicator[idx].Pending_Label_Color == pending_Label_Color && cachehpcPatternsIndicator[idx].Pending_Leg_Color == pending_Leg_Color && cachehpcPatternsIndicator[idx].Pending_RatioLabel_Color == pending_RatioLabel_Color && cachehpcPatternsIndicator[idx].Pending_RatioLine_Color == pending_RatioLine_Color && cachehpcPatternsIndicator[idx].Potential_Label_Color == potential_Label_Color && cachehpcPatternsIndicator[idx].Potential_Leg_Color == potential_Leg_Color && cachehpcPatternsIndicator[idx].Potential_Logic == potential_Logic && cachehpcPatternsIndicator[idx].Potential_RatioLabel_Color == potential_RatioLabel_Color && cachehpcPatternsIndicator[idx].Potential_RatioLine_Color == potential_RatioLine_Color && cachehpcPatternsIndicator[idx].Ratio_Font_Size == ratio_Font_Size && Math.Abs(cachehpcPatternsIndicator[idx].Ratio_Thickness - ratio_Thickness) <= double.Epsilon && cachehpcPatternsIndicator[idx].Reverse_Zone_Labels == reverse_Zone_Labels && cachehpcPatternsIndicator[idx].Show_50 == show_50 && cachehpcPatternsIndicator[idx].Show_ABCD == show_ABCD && cachehpcPatternsIndicator[idx].Show_AltBat == show_AltBat && cachehpcPatternsIndicator[idx].Show_Bat == show_Bat && cachehpcPatternsIndicator[idx].Show_Bearish == show_Bearish && cachehpcPatternsIndicator[idx].Show_Bullish == show_Bullish && cachehpcPatternsIndicator[idx].Show_Butterfly == show_Butterfly && cachehpcPatternsIndicator[idx].Show_Crab == show_Crab && cachehpcPatternsIndicator[idx].Show_DeepCrab == show_DeepCrab && cachehpcPatternsIndicator[idx].Show_Gartley == show_Gartley && cachehpcPatternsIndicator[idx].Show_LicenseButton == show_LicenseButton && cachehpcPatternsIndicator[idx].Show_Pending == show_Pending && cachehpcPatternsIndicator[idx].Show_Potential == show_Potential && cachehpcPatternsIndicator[idx].Show_Shark == show_Shark && cachehpcPatternsIndicator[idx].Show_Vertical_Line == show_Vertical_Line && cachehpcPatternsIndicator[idx].Strict_ABCD == strict_ABCD && Math.Abs(cachehpcPatternsIndicator[idx].Strict_ATRs - strict_ATRs) <= double.Epsilon && cachehpcPatternsIndicator[idx].Target_Bars == target_Bars && cachehpcPatternsIndicator[idx].Terminal_Bar_Font == terminal_Bar_Font && cachehpcPatternsIndicator[idx].Update_Interval == update_Interval && cachehpcPatternsIndicator[idx].Update_Type == update_Type && cachehpcPatternsIndicator[idx].Zone_Bars == zone_Bars && cachehpcPatternsIndicator[idx].Zone_Line_Bearish == zone_Line_Bearish && cachehpcPatternsIndicator[idx].Zone_Line_Bullish == zone_Line_Bullish && Math.Abs(cachehpcPatternsIndicator[idx].Zone_Line_Thickness - zone_Line_Thickness) <= double.Epsilon && Math.Abs(cachehpcPatternsIndicator[idx].Zone_Opacity - zone_Opacity) <= double.Epsilon && cachehpcPatternsIndicator[idx].Zone_Text_Color == zone_Text_Color && cachehpcPatternsIndicator[idx].Zone_Text_FontSize == zone_Text_FontSize && cachehpcPatternsIndicator[idx].EqualsInput(input))
                            return cachehpcPatternsIndicator[idx];

                hpcPatternsIndicator indicator = new hpcPatternsIndicator();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bars_To_Process = bars_To_Process;
                indicator.Bearish_Leg_Color = bearish_Leg_Color;
                indicator.Bullish_Leg_Color = bullish_Leg_Color;
                indicator.Confirmed_Label_Color = confirmed_Label_Color;
                indicator.Confirmed_RatioLabel_Color = confirmed_RatioLabel_Color;
                indicator.Confirmed_RatioLine_Color = confirmed_RatioLine_Color;
                indicator.Do_Alerts = do_Alerts;
                indicator.Do_Pattern_Fill = do_Pattern_Fill;
                indicator.Fill_Opacity = fill_Opacity;
                indicator.Hide_Inside = hide_Inside;
                indicator.Label_Font_Size = label_Font_Size;
                indicator.Leg_Thickness = leg_Thickness;
                indicator.Max_Pattern_Length = max_Pattern_Length;
                indicator.Max_Points_Shared = max_Points_Shared;
                indicator.Min_Pattern_Length = min_Pattern_Length;
                indicator.Most_Recent = most_Recent;
                indicator.None_Past_AC = none_Past_AC;
                indicator.None_Past_BD = none_Past_BD;
                indicator.Pending_Label_Color = pending_Label_Color;
                indicator.Pending_Leg_Color = pending_Leg_Color;
                indicator.Pending_RatioLabel_Color = pending_RatioLabel_Color;
                indicator.Pending_RatioLine_Color = pending_RatioLine_Color;
                indicator.Potential_Label_Color = potential_Label_Color;
                indicator.Potential_Leg_Color = potential_Leg_Color;
                indicator.Potential_Logic = potential_Logic;
                indicator.Potential_RatioLabel_Color = potential_RatioLabel_Color;
                indicator.Potential_RatioLine_Color = potential_RatioLine_Color;
                indicator.Ratio_Font_Size = ratio_Font_Size;
                indicator.Ratio_Thickness = ratio_Thickness;
                indicator.Reverse_Zone_Labels = reverse_Zone_Labels;
                indicator.Show_50 = show_50;
                indicator.Show_ABCD = show_ABCD;
                indicator.Show_AltBat = show_AltBat;
                indicator.Show_Bat = show_Bat;
                indicator.Show_Bearish = show_Bearish;
                indicator.Show_Bullish = show_Bullish;
                indicator.Show_Butterfly = show_Butterfly;
                indicator.Show_Crab = show_Crab;
                indicator.Show_DeepCrab = show_DeepCrab;
                indicator.Show_Gartley = show_Gartley;
                indicator.Show_LicenseButton = show_LicenseButton;
                indicator.Show_Pending = show_Pending;
                indicator.Show_Potential = show_Potential;
                indicator.Show_Shark = show_Shark;
                indicator.Show_Vertical_Line = show_Vertical_Line;
                indicator.Strict_ABCD = strict_ABCD;
                indicator.Strict_ATRs = strict_ATRs;
                indicator.Target_Bars = target_Bars;
                indicator.Terminal_Bar_Font = terminal_Bar_Font;
                indicator.Update_Interval = update_Interval;
                indicator.Update_Type = update_Type;
                indicator.Zone_Bars = zone_Bars;
                indicator.Zone_Line_Bearish = zone_Line_Bearish;
                indicator.Zone_Line_Bullish = zone_Line_Bullish;
                indicator.Zone_Line_Thickness = zone_Line_Thickness;
                indicator.Zone_Opacity = zone_Opacity;
                indicator.Zone_Text_Color = zone_Text_Color;
                indicator.Zone_Text_FontSize = zone_Text_FontSize;
                Indicators.Add(indicator);
                indicator.SetUp();

                hpcPatternsIndicator[] tmp = new hpcPatternsIndicator[cachehpcPatternsIndicator == null ? 1 : cachehpcPatternsIndicator.Length + 1];
                if (cachehpcPatternsIndicator != null)
                    cachehpcPatternsIndicator.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachehpcPatternsIndicator = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Pi Phi Bands
        /// </summary>
        /// <returns></returns>
        public hpcPiPhiBands hpcPiPhiBands()
        {
            return hpcPiPhiBands(Input);
        }

        /// <summary>
        /// Pi Phi Bands
        /// </summary>
        /// <returns></returns>
        public hpcPiPhiBands hpcPiPhiBands(Data.IDataSeries input)
        {
            if (cachehpcPiPhiBands != null)
                for (int idx = 0; idx < cachehpcPiPhiBands.Length; idx++)
                    if (cachehpcPiPhiBands[idx].EqualsInput(input))
                        return cachehpcPiPhiBands[idx];

            lock (checkhpcPiPhiBands)
            {
                if (cachehpcPiPhiBands != null)
                    for (int idx = 0; idx < cachehpcPiPhiBands.Length; idx++)
                        if (cachehpcPiPhiBands[idx].EqualsInput(input))
                            return cachehpcPiPhiBands[idx];

                hpcPiPhiBands indicator = new hpcPiPhiBands();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                hpcPiPhiBands[] tmp = new hpcPiPhiBands[cachehpcPiPhiBands == null ? 1 : cachehpcPiPhiBands.Length + 1];
                if (cachehpcPiPhiBands != null)
                    cachehpcPiPhiBands.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachehpcPiPhiBands = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// RSI Bamm Indicator
        /// </summary>
        /// <returns></returns>
        public hpcRSIBammIndicator hpcRSIBammIndicator(double fill_Opacity, Color fillColor)
        {
            return hpcRSIBammIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// RSI Bamm Indicator
        /// </summary>
        /// <returns></returns>
        public hpcRSIBammIndicator hpcRSIBammIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            if (cachehpcRSIBammIndicator != null)
                for (int idx = 0; idx < cachehpcRSIBammIndicator.Length; idx++)
                    if (Math.Abs(cachehpcRSIBammIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcRSIBammIndicator[idx].FillColor == fillColor && cachehpcRSIBammIndicator[idx].EqualsInput(input))
                        return cachehpcRSIBammIndicator[idx];

            lock (checkhpcRSIBammIndicator)
            {
                checkhpcRSIBammIndicator.Fill_Opacity = fill_Opacity;
                fill_Opacity = checkhpcRSIBammIndicator.Fill_Opacity;
                checkhpcRSIBammIndicator.FillColor = fillColor;
                fillColor = checkhpcRSIBammIndicator.FillColor;

                if (cachehpcRSIBammIndicator != null)
                    for (int idx = 0; idx < cachehpcRSIBammIndicator.Length; idx++)
                        if (Math.Abs(cachehpcRSIBammIndicator[idx].Fill_Opacity - fill_Opacity) <= double.Epsilon && cachehpcRSIBammIndicator[idx].FillColor == fillColor && cachehpcRSIBammIndicator[idx].EqualsInput(input))
                            return cachehpcRSIBammIndicator[idx];

                hpcRSIBammIndicator indicator = new hpcRSIBammIndicator();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Fill_Opacity = fill_Opacity;
                indicator.FillColor = fillColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                hpcRSIBammIndicator[] tmp = new hpcRSIBammIndicator[cachehpcRSIBammIndicator == null ? 1 : cachehpcRSIBammIndicator.Length + 1];
                if (cachehpcRSIBammIndicator != null)
                    cachehpcRSIBammIndicator.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachehpcRSIBammIndicator = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Volume Spike
        /// </summary>
        /// <returns></returns>
        public hpcVolumeSpike hpcVolumeSpike(int period, Color up_Arrow_Color)
        {
            return hpcVolumeSpike(Input, period, up_Arrow_Color);
        }

        /// <summary>
        /// Volume Spike
        /// </summary>
        /// <returns></returns>
        public hpcVolumeSpike hpcVolumeSpike(Data.IDataSeries input, int period, Color up_Arrow_Color)
        {
            if (cachehpcVolumeSpike != null)
                for (int idx = 0; idx < cachehpcVolumeSpike.Length; idx++)
                    if (cachehpcVolumeSpike[idx].Period == period && cachehpcVolumeSpike[idx].Up_Arrow_Color == up_Arrow_Color && cachehpcVolumeSpike[idx].EqualsInput(input))
                        return cachehpcVolumeSpike[idx];

            lock (checkhpcVolumeSpike)
            {
                checkhpcVolumeSpike.Period = period;
                period = checkhpcVolumeSpike.Period;
                checkhpcVolumeSpike.Up_Arrow_Color = up_Arrow_Color;
                up_Arrow_Color = checkhpcVolumeSpike.Up_Arrow_Color;

                if (cachehpcVolumeSpike != null)
                    for (int idx = 0; idx < cachehpcVolumeSpike.Length; idx++)
                        if (cachehpcVolumeSpike[idx].Period == period && cachehpcVolumeSpike[idx].Up_Arrow_Color == up_Arrow_Color && cachehpcVolumeSpike[idx].EqualsInput(input))
                            return cachehpcVolumeSpike[idx];

                hpcVolumeSpike indicator = new hpcVolumeSpike();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                indicator.Up_Arrow_Color = up_Arrow_Color;
                Indicators.Add(indicator);
                indicator.SetUp();

                hpcVolumeSpike[] tmp = new hpcVolumeSpike[cachehpcVolumeSpike == null ? 1 : cachehpcVolumeSpike.Length + 1];
                if (cachehpcVolumeSpike != null)
                    cachehpcVolumeSpike.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachehpcVolumeSpike = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Amp RSI Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcAmpRSIIndicator hpcAmpRSIIndicator(double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcAmpRSIIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Amp RSI Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcAmpRSIIndicator hpcAmpRSIIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcAmpRSIIndicator(input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Harmonic Strength Indicator Arrows
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcHSIArrowsIndicator hpcHSIArrowsIndicator(Color dn_Arrow_Color, Color up_Arrow_Color)
        {
            return _indicator.hpcHSIArrowsIndicator(Input, dn_Arrow_Color, up_Arrow_Color);
        }

        /// <summary>
        /// Harmonic Strength Indicator Arrows
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcHSIArrowsIndicator hpcHSIArrowsIndicator(Data.IDataSeries input, Color dn_Arrow_Color, Color up_Arrow_Color)
        {
            return _indicator.hpcHSIArrowsIndicator(input, dn_Arrow_Color, up_Arrow_Color);
        }

        /// <summary>
        /// Harmonic Strength Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcHSIIndicator hpcHSIIndicator(double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcHSIIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Harmonic Strength Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcHSIIndicator hpcHSIIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcHSIIndicator(input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Harmonic Patterns Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcPatternsIndicator hpcPatternsIndicator(int bars_To_Process, Color bearish_Leg_Color, Color bullish_Leg_Color, Color confirmed_Label_Color, Color confirmed_RatioLabel_Color, Color confirmed_RatioLine_Color, bool do_Alerts, bool do_Pattern_Fill, double fill_Opacity, bool hide_Inside, int label_Font_Size, double leg_Thickness, int max_Pattern_Length, int max_Points_Shared, int min_Pattern_Length, int most_Recent, bool none_Past_AC, bool none_Past_BD, Color pending_Label_Color, Color pending_Leg_Color, Color pending_RatioLabel_Color, Color pending_RatioLine_Color, Color potential_Label_Color, Color potential_Leg_Color, int potential_Logic, Color potential_RatioLabel_Color, Color potential_RatioLine_Color, int ratio_Font_Size, double ratio_Thickness, bool reverse_Zone_Labels, bool show_50, bool show_ABCD, bool show_AltBat, bool show_Bat, bool show_Bearish, bool show_Bullish, bool show_Butterfly, bool show_Crab, bool show_DeepCrab, bool show_Gartley, bool show_LicenseButton, bool show_Pending, bool show_Potential, bool show_Shark, bool show_Vertical_Line, bool strict_ABCD, double strict_ATRs, int target_Bars, int terminal_Bar_Font, int update_Interval, int update_Type, int zone_Bars, Color zone_Line_Bearish, Color zone_Line_Bullish, double zone_Line_Thickness, double zone_Opacity, Color zone_Text_Color, int zone_Text_FontSize)
        {
            return _indicator.hpcPatternsIndicator(Input, bars_To_Process, bearish_Leg_Color, bullish_Leg_Color, confirmed_Label_Color, confirmed_RatioLabel_Color, confirmed_RatioLine_Color, do_Alerts, do_Pattern_Fill, fill_Opacity, hide_Inside, label_Font_Size, leg_Thickness, max_Pattern_Length, max_Points_Shared, min_Pattern_Length, most_Recent, none_Past_AC, none_Past_BD, pending_Label_Color, pending_Leg_Color, pending_RatioLabel_Color, pending_RatioLine_Color, potential_Label_Color, potential_Leg_Color, potential_Logic, potential_RatioLabel_Color, potential_RatioLine_Color, ratio_Font_Size, ratio_Thickness, reverse_Zone_Labels, show_50, show_ABCD, show_AltBat, show_Bat, show_Bearish, show_Bullish, show_Butterfly, show_Crab, show_DeepCrab, show_Gartley, show_LicenseButton, show_Pending, show_Potential, show_Shark, show_Vertical_Line, strict_ABCD, strict_ATRs, target_Bars, terminal_Bar_Font, update_Interval, update_Type, zone_Bars, zone_Line_Bearish, zone_Line_Bullish, zone_Line_Thickness, zone_Opacity, zone_Text_Color, zone_Text_FontSize);
        }

        /// <summary>
        /// Harmonic Patterns Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcPatternsIndicator hpcPatternsIndicator(Data.IDataSeries input, int bars_To_Process, Color bearish_Leg_Color, Color bullish_Leg_Color, Color confirmed_Label_Color, Color confirmed_RatioLabel_Color, Color confirmed_RatioLine_Color, bool do_Alerts, bool do_Pattern_Fill, double fill_Opacity, bool hide_Inside, int label_Font_Size, double leg_Thickness, int max_Pattern_Length, int max_Points_Shared, int min_Pattern_Length, int most_Recent, bool none_Past_AC, bool none_Past_BD, Color pending_Label_Color, Color pending_Leg_Color, Color pending_RatioLabel_Color, Color pending_RatioLine_Color, Color potential_Label_Color, Color potential_Leg_Color, int potential_Logic, Color potential_RatioLabel_Color, Color potential_RatioLine_Color, int ratio_Font_Size, double ratio_Thickness, bool reverse_Zone_Labels, bool show_50, bool show_ABCD, bool show_AltBat, bool show_Bat, bool show_Bearish, bool show_Bullish, bool show_Butterfly, bool show_Crab, bool show_DeepCrab, bool show_Gartley, bool show_LicenseButton, bool show_Pending, bool show_Potential, bool show_Shark, bool show_Vertical_Line, bool strict_ABCD, double strict_ATRs, int target_Bars, int terminal_Bar_Font, int update_Interval, int update_Type, int zone_Bars, Color zone_Line_Bearish, Color zone_Line_Bullish, double zone_Line_Thickness, double zone_Opacity, Color zone_Text_Color, int zone_Text_FontSize)
        {
            return _indicator.hpcPatternsIndicator(input, bars_To_Process, bearish_Leg_Color, bullish_Leg_Color, confirmed_Label_Color, confirmed_RatioLabel_Color, confirmed_RatioLine_Color, do_Alerts, do_Pattern_Fill, fill_Opacity, hide_Inside, label_Font_Size, leg_Thickness, max_Pattern_Length, max_Points_Shared, min_Pattern_Length, most_Recent, none_Past_AC, none_Past_BD, pending_Label_Color, pending_Leg_Color, pending_RatioLabel_Color, pending_RatioLine_Color, potential_Label_Color, potential_Leg_Color, potential_Logic, potential_RatioLabel_Color, potential_RatioLine_Color, ratio_Font_Size, ratio_Thickness, reverse_Zone_Labels, show_50, show_ABCD, show_AltBat, show_Bat, show_Bearish, show_Bullish, show_Butterfly, show_Crab, show_DeepCrab, show_Gartley, show_LicenseButton, show_Pending, show_Potential, show_Shark, show_Vertical_Line, strict_ABCD, strict_ATRs, target_Bars, terminal_Bar_Font, update_Interval, update_Type, zone_Bars, zone_Line_Bearish, zone_Line_Bullish, zone_Line_Thickness, zone_Opacity, zone_Text_Color, zone_Text_FontSize);
        }

        /// <summary>
        /// Pi Phi Bands
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcPiPhiBands hpcPiPhiBands()
        {
            return _indicator.hpcPiPhiBands(Input);
        }

        /// <summary>
        /// Pi Phi Bands
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcPiPhiBands hpcPiPhiBands(Data.IDataSeries input)
        {
            return _indicator.hpcPiPhiBands(input);
        }

        /// <summary>
        /// RSI Bamm Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcRSIBammIndicator hpcRSIBammIndicator(double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcRSIBammIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// RSI Bamm Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcRSIBammIndicator hpcRSIBammIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcRSIBammIndicator(input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Volume Spike
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcVolumeSpike hpcVolumeSpike(int period, Color up_Arrow_Color)
        {
            return _indicator.hpcVolumeSpike(Input, period, up_Arrow_Color);
        }

        /// <summary>
        /// Volume Spike
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcVolumeSpike hpcVolumeSpike(Data.IDataSeries input, int period, Color up_Arrow_Color)
        {
            return _indicator.hpcVolumeSpike(input, period, up_Arrow_Color);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Amp RSI Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcAmpRSIIndicator hpcAmpRSIIndicator(double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcAmpRSIIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Amp RSI Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcAmpRSIIndicator hpcAmpRSIIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.hpcAmpRSIIndicator(input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Harmonic Strength Indicator Arrows
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcHSIArrowsIndicator hpcHSIArrowsIndicator(Color dn_Arrow_Color, Color up_Arrow_Color)
        {
            return _indicator.hpcHSIArrowsIndicator(Input, dn_Arrow_Color, up_Arrow_Color);
        }

        /// <summary>
        /// Harmonic Strength Indicator Arrows
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcHSIArrowsIndicator hpcHSIArrowsIndicator(Data.IDataSeries input, Color dn_Arrow_Color, Color up_Arrow_Color)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.hpcHSIArrowsIndicator(input, dn_Arrow_Color, up_Arrow_Color);
        }

        /// <summary>
        /// Harmonic Strength Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcHSIIndicator hpcHSIIndicator(double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcHSIIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Harmonic Strength Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcHSIIndicator hpcHSIIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.hpcHSIIndicator(input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Harmonic Patterns Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcPatternsIndicator hpcPatternsIndicator(int bars_To_Process, Color bearish_Leg_Color, Color bullish_Leg_Color, Color confirmed_Label_Color, Color confirmed_RatioLabel_Color, Color confirmed_RatioLine_Color, bool do_Alerts, bool do_Pattern_Fill, double fill_Opacity, bool hide_Inside, int label_Font_Size, double leg_Thickness, int max_Pattern_Length, int max_Points_Shared, int min_Pattern_Length, int most_Recent, bool none_Past_AC, bool none_Past_BD, Color pending_Label_Color, Color pending_Leg_Color, Color pending_RatioLabel_Color, Color pending_RatioLine_Color, Color potential_Label_Color, Color potential_Leg_Color, int potential_Logic, Color potential_RatioLabel_Color, Color potential_RatioLine_Color, int ratio_Font_Size, double ratio_Thickness, bool reverse_Zone_Labels, bool show_50, bool show_ABCD, bool show_AltBat, bool show_Bat, bool show_Bearish, bool show_Bullish, bool show_Butterfly, bool show_Crab, bool show_DeepCrab, bool show_Gartley, bool show_LicenseButton, bool show_Pending, bool show_Potential, bool show_Shark, bool show_Vertical_Line, bool strict_ABCD, double strict_ATRs, int target_Bars, int terminal_Bar_Font, int update_Interval, int update_Type, int zone_Bars, Color zone_Line_Bearish, Color zone_Line_Bullish, double zone_Line_Thickness, double zone_Opacity, Color zone_Text_Color, int zone_Text_FontSize)
        {
            return _indicator.hpcPatternsIndicator(Input, bars_To_Process, bearish_Leg_Color, bullish_Leg_Color, confirmed_Label_Color, confirmed_RatioLabel_Color, confirmed_RatioLine_Color, do_Alerts, do_Pattern_Fill, fill_Opacity, hide_Inside, label_Font_Size, leg_Thickness, max_Pattern_Length, max_Points_Shared, min_Pattern_Length, most_Recent, none_Past_AC, none_Past_BD, pending_Label_Color, pending_Leg_Color, pending_RatioLabel_Color, pending_RatioLine_Color, potential_Label_Color, potential_Leg_Color, potential_Logic, potential_RatioLabel_Color, potential_RatioLine_Color, ratio_Font_Size, ratio_Thickness, reverse_Zone_Labels, show_50, show_ABCD, show_AltBat, show_Bat, show_Bearish, show_Bullish, show_Butterfly, show_Crab, show_DeepCrab, show_Gartley, show_LicenseButton, show_Pending, show_Potential, show_Shark, show_Vertical_Line, strict_ABCD, strict_ATRs, target_Bars, terminal_Bar_Font, update_Interval, update_Type, zone_Bars, zone_Line_Bearish, zone_Line_Bullish, zone_Line_Thickness, zone_Opacity, zone_Text_Color, zone_Text_FontSize);
        }

        /// <summary>
        /// Harmonic Patterns Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcPatternsIndicator hpcPatternsIndicator(Data.IDataSeries input, int bars_To_Process, Color bearish_Leg_Color, Color bullish_Leg_Color, Color confirmed_Label_Color, Color confirmed_RatioLabel_Color, Color confirmed_RatioLine_Color, bool do_Alerts, bool do_Pattern_Fill, double fill_Opacity, bool hide_Inside, int label_Font_Size, double leg_Thickness, int max_Pattern_Length, int max_Points_Shared, int min_Pattern_Length, int most_Recent, bool none_Past_AC, bool none_Past_BD, Color pending_Label_Color, Color pending_Leg_Color, Color pending_RatioLabel_Color, Color pending_RatioLine_Color, Color potential_Label_Color, Color potential_Leg_Color, int potential_Logic, Color potential_RatioLabel_Color, Color potential_RatioLine_Color, int ratio_Font_Size, double ratio_Thickness, bool reverse_Zone_Labels, bool show_50, bool show_ABCD, bool show_AltBat, bool show_Bat, bool show_Bearish, bool show_Bullish, bool show_Butterfly, bool show_Crab, bool show_DeepCrab, bool show_Gartley, bool show_LicenseButton, bool show_Pending, bool show_Potential, bool show_Shark, bool show_Vertical_Line, bool strict_ABCD, double strict_ATRs, int target_Bars, int terminal_Bar_Font, int update_Interval, int update_Type, int zone_Bars, Color zone_Line_Bearish, Color zone_Line_Bullish, double zone_Line_Thickness, double zone_Opacity, Color zone_Text_Color, int zone_Text_FontSize)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.hpcPatternsIndicator(input, bars_To_Process, bearish_Leg_Color, bullish_Leg_Color, confirmed_Label_Color, confirmed_RatioLabel_Color, confirmed_RatioLine_Color, do_Alerts, do_Pattern_Fill, fill_Opacity, hide_Inside, label_Font_Size, leg_Thickness, max_Pattern_Length, max_Points_Shared, min_Pattern_Length, most_Recent, none_Past_AC, none_Past_BD, pending_Label_Color, pending_Leg_Color, pending_RatioLabel_Color, pending_RatioLine_Color, potential_Label_Color, potential_Leg_Color, potential_Logic, potential_RatioLabel_Color, potential_RatioLine_Color, ratio_Font_Size, ratio_Thickness, reverse_Zone_Labels, show_50, show_ABCD, show_AltBat, show_Bat, show_Bearish, show_Bullish, show_Butterfly, show_Crab, show_DeepCrab, show_Gartley, show_LicenseButton, show_Pending, show_Potential, show_Shark, show_Vertical_Line, strict_ABCD, strict_ATRs, target_Bars, terminal_Bar_Font, update_Interval, update_Type, zone_Bars, zone_Line_Bearish, zone_Line_Bullish, zone_Line_Thickness, zone_Opacity, zone_Text_Color, zone_Text_FontSize);
        }

        /// <summary>
        /// Pi Phi Bands
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcPiPhiBands hpcPiPhiBands()
        {
            return _indicator.hpcPiPhiBands(Input);
        }

        /// <summary>
        /// Pi Phi Bands
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcPiPhiBands hpcPiPhiBands(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.hpcPiPhiBands(input);
        }

        /// <summary>
        /// RSI Bamm Indicator
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcRSIBammIndicator hpcRSIBammIndicator(double fill_Opacity, Color fillColor)
        {
            return _indicator.hpcRSIBammIndicator(Input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// RSI Bamm Indicator
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcRSIBammIndicator hpcRSIBammIndicator(Data.IDataSeries input, double fill_Opacity, Color fillColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.hpcRSIBammIndicator(input, fill_Opacity, fillColor);
        }

        /// <summary>
        /// Volume Spike
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.hpcVolumeSpike hpcVolumeSpike(int period, Color up_Arrow_Color)
        {
            return _indicator.hpcVolumeSpike(Input, period, up_Arrow_Color);
        }

        /// <summary>
        /// Volume Spike
        /// </summary>
        /// <returns></returns>
        public Indicator.hpcVolumeSpike hpcVolumeSpike(Data.IDataSeries input, int period, Color up_Arrow_Color)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.hpcVolumeSpike(input, period, up_Arrow_Color);
        }
    }
}
#endregion
